"""autogenerated by genpy from cogman_msgs/ArmHandGoal.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class ArmHandGoal(genpy.Message):
  _md5sum = "3a564cf8a4d7611dab9e91da15079bfc"
  _type = "cogman_msgs/ArmHandGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
string command              # 'arm_cart_loid', 'arm_cart_pose', 'arm_cart_name', 'arm_joints', 'arm_joint_name', 'reach_primitive', 'hand_primitive', 'lift', 'put_down'
string pose_name            # When moving to pre-defined poses, cointains the name
float32[] joint_angles      # If command is 'arm_joints', the joint angles
geometry_msgs/Pose end_effector_pose  # command=arm_cart_pose: where the arm should go
uint64 end_effector_loid    # one lo_id where the arm should go
string hand_primitive       # Allowed strings: open open_thumb90 3pinch 2pinch cup_top peace handshake noop. Used when command is 'finger_primitive'
string object_type          # If command is 'reach_primitive', it will define how to grasp (orientation ...)
uint64[] obstacle_ids       # List of lo_id's corresponding to obstacles
float32 distance            # For reach_primitive: distance from grasp point to approach point (m). For 'lift', distance to lift up (m)
float32 supporting_plane    # Height of the table (m)

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['command','pose_name','joint_angles','end_effector_pose','end_effector_loid','hand_primitive','object_type','obstacle_ids','distance','supporting_plane']
  _slot_types = ['string','string','float32[]','geometry_msgs/Pose','uint64','string','string','uint64[]','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       command,pose_name,joint_angles,end_effector_pose,end_effector_loid,hand_primitive,object_type,obstacle_ids,distance,supporting_plane

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ArmHandGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = ''
      if self.pose_name is None:
        self.pose_name = ''
      if self.joint_angles is None:
        self.joint_angles = []
      if self.end_effector_pose is None:
        self.end_effector_pose = geometry_msgs.msg.Pose()
      if self.end_effector_loid is None:
        self.end_effector_loid = 0
      if self.hand_primitive is None:
        self.hand_primitive = ''
      if self.object_type is None:
        self.object_type = ''
      if self.obstacle_ids is None:
        self.obstacle_ids = []
      if self.distance is None:
        self.distance = 0.
      if self.supporting_plane is None:
        self.supporting_plane = 0.
    else:
      self.command = ''
      self.pose_name = ''
      self.joint_angles = []
      self.end_effector_pose = geometry_msgs.msg.Pose()
      self.end_effector_loid = 0
      self.hand_primitive = ''
      self.object_type = ''
      self.obstacle_ids = []
      self.distance = 0.
      self.supporting_plane = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.command
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pose_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.joint_angles)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.joint_angles))
      _x = self
      buff.write(_struct_7dQ.pack(_x.end_effector_pose.position.x, _x.end_effector_pose.position.y, _x.end_effector_pose.position.z, _x.end_effector_pose.orientation.x, _x.end_effector_pose.orientation.y, _x.end_effector_pose.orientation.z, _x.end_effector_pose.orientation.w, _x.end_effector_loid))
      _x = self.hand_primitive
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.obstacle_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.pack(pattern, *self.obstacle_ids))
      _x = self
      buff.write(_struct_2f.pack(_x.distance, _x.supporting_plane))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.end_effector_pose is None:
        self.end_effector_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command = str[start:end].decode('utf-8')
      else:
        self.command = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_name = str[start:end].decode('utf-8')
      else:
        self.pose_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.joint_angles = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 64
      (_x.end_effector_pose.position.x, _x.end_effector_pose.position.y, _x.end_effector_pose.position.z, _x.end_effector_pose.orientation.x, _x.end_effector_pose.orientation.y, _x.end_effector_pose.orientation.z, _x.end_effector_pose.orientation.w, _x.end_effector_loid,) = _struct_7dQ.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hand_primitive = str[start:end].decode('utf-8')
      else:
        self.hand_primitive = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_type = str[start:end].decode('utf-8')
      else:
        self.object_type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.obstacle_ids = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 8
      (_x.distance, _x.supporting_plane,) = _struct_2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.command
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pose_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.joint_angles)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.joint_angles.tostring())
      _x = self
      buff.write(_struct_7dQ.pack(_x.end_effector_pose.position.x, _x.end_effector_pose.position.y, _x.end_effector_pose.position.z, _x.end_effector_pose.orientation.x, _x.end_effector_pose.orientation.y, _x.end_effector_pose.orientation.z, _x.end_effector_pose.orientation.w, _x.end_effector_loid))
      _x = self.hand_primitive
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.object_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.obstacle_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.obstacle_ids.tostring())
      _x = self
      buff.write(_struct_2f.pack(_x.distance, _x.supporting_plane))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.end_effector_pose is None:
        self.end_effector_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.command = str[start:end].decode('utf-8')
      else:
        self.command = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_name = str[start:end].decode('utf-8')
      else:
        self.pose_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.joint_angles = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 64
      (_x.end_effector_pose.position.x, _x.end_effector_pose.position.y, _x.end_effector_pose.position.z, _x.end_effector_pose.orientation.x, _x.end_effector_pose.orientation.y, _x.end_effector_pose.orientation.z, _x.end_effector_pose.orientation.w, _x.end_effector_loid,) = _struct_7dQ.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hand_primitive = str[start:end].decode('utf-8')
      else:
        self.hand_primitive = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.object_type = str[start:end].decode('utf-8')
      else:
        self.object_type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.obstacle_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 8
      (_x.distance, _x.supporting_plane,) = _struct_2f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_7dQ = struct.Struct("<7dQ")
_struct_2f = struct.Struct("<2f")
