"""autogenerated by genpy from cogman_msgs/ArmHandResult.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import vision_msgs.msg

class ArmHandResult(genpy.Message):
  _md5sum = "96fe826375e10406e4d32548d703c09c"
  _type = "cogman_msgs/ArmHandResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

#result
float32 distance_to_goal
string situation            #Allowed: grasped slipped released unreachable ik_deadlock need_to_move_base
vision_msgs/system_error error   #Description of error
uint64[] better_base_ids    #List of lo_id's where we could grasp better

================================================================================
MSG: vision_msgs/system_error
uint64 MANIPULATION_POSE_UNREACHABLE = 64
uint64 GRASP_FAILED = 128  # Grasp into the void
uint64 OBJECT_NOT_FOUND = 256
uint64 VISION_PRIMITIVE_FAILED = 512
uint64 CONTRADICTING_TACTILE_FEEDBACK = 1024  # Collide without expecting it
uint64 CONTRADICTING_VISION_RESULTS = 2048
uint64 GRASP_FAILED_AND_CRASHED = 4096  # Throwing something out of the way
uint64 JLO_ERROR = 8192  # Could not get position
uint64 VECTOR_FIELD_CANT_REACH = 16384  # The arm got stuck along the way, did not reach the final grasping pose

uint64  error_id                # One of the error constants defined above
string  node_name               # The node causing this error
string  error_description       # Further information about the error

"""
  __slots__ = ['distance_to_goal','situation','error','better_base_ids']
  _slot_types = ['float32','string','vision_msgs/system_error','uint64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       distance_to_goal,situation,error,better_base_ids

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ArmHandResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.distance_to_goal is None:
        self.distance_to_goal = 0.
      if self.situation is None:
        self.situation = ''
      if self.error is None:
        self.error = vision_msgs.msg.system_error()
      if self.better_base_ids is None:
        self.better_base_ids = []
    else:
      self.distance_to_goal = 0.
      self.situation = ''
      self.error = vision_msgs.msg.system_error()
      self.better_base_ids = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_f.pack(self.distance_to_goal))
      _x = self.situation
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_Q.pack(self.error.error_id))
      _x = self.error.node_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.error.error_description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.better_base_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.pack(pattern, *self.better_base_ids))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.error is None:
        self.error = vision_msgs.msg.system_error()
      end = 0
      start = end
      end += 4
      (self.distance_to_goal,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.situation = str[start:end].decode('utf-8')
      else:
        self.situation = str[start:end]
      start = end
      end += 8
      (self.error.error_id,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error.node_name = str[start:end].decode('utf-8')
      else:
        self.error.node_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error.error_description = str[start:end].decode('utf-8')
      else:
        self.error.error_description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.better_base_ids = struct.unpack(pattern, str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_f.pack(self.distance_to_goal))
      _x = self.situation
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_Q.pack(self.error.error_id))
      _x = self.error.node_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.error.error_description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.better_base_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.better_base_ids.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.error is None:
        self.error = vision_msgs.msg.system_error()
      end = 0
      start = end
      end += 4
      (self.distance_to_goal,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.situation = str[start:end].decode('utf-8')
      else:
        self.situation = str[start:end]
      start = end
      end += 8
      (self.error.error_id,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error.node_name = str[start:end].decode('utf-8')
      else:
        self.error.node_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error.error_description = str[start:end].decode('utf-8')
      else:
        self.error.error_description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.better_base_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
_struct_f = struct.Struct("<f")
