/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-fuerte-ias-common-0.1.3/debian/ros-fuerte-ias-common/opt/ros/fuerte/stacks/ias_common/vision_msgs/msg/system_error.msg */
#ifndef VISION_MSGS_MESSAGE_SYSTEM_ERROR_H
#define VISION_MSGS_MESSAGE_SYSTEM_ERROR_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"


namespace vision_msgs
{
template <class ContainerAllocator>
struct system_error_ {
  typedef system_error_<ContainerAllocator> Type;

  system_error_()
  : error_id(0)
  , node_name()
  , error_description()
  {
  }

  system_error_(const ContainerAllocator& _alloc)
  : error_id(0)
  , node_name(_alloc)
  , error_description(_alloc)
  {
  }

  typedef uint64_t _error_id_type;
  uint64_t error_id;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _node_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  node_name;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _error_description_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  error_description;

  enum { MANIPULATION_POSE_UNREACHABLE = 64 };
  enum { GRASP_FAILED = 128 };
  enum { OBJECT_NOT_FOUND = 256 };
  enum { VISION_PRIMITIVE_FAILED = 512 };
  enum { CONTRADICTING_TACTILE_FEEDBACK = 1024 };
  enum { CONTRADICTING_VISION_RESULTS = 2048 };
  enum { GRASP_FAILED_AND_CRASHED = 4096 };
  enum { JLO_ERROR = 8192 };
  enum { VECTOR_FIELD_CANT_REACH = 16384 };

  typedef boost::shared_ptr< ::vision_msgs::system_error_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::vision_msgs::system_error_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct system_error
typedef  ::vision_msgs::system_error_<std::allocator<void> > system_error;

typedef boost::shared_ptr< ::vision_msgs::system_error> system_errorPtr;
typedef boost::shared_ptr< ::vision_msgs::system_error const> system_errorConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::vision_msgs::system_error_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::vision_msgs::system_error_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace vision_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::vision_msgs::system_error_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::vision_msgs::system_error_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::vision_msgs::system_error_<ContainerAllocator> > {
  static const char* value() 
  {
    return "a26e239d3a42fd6822d79621c90c2d42";
  }

  static const char* value(const  ::vision_msgs::system_error_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xa26e239d3a42fd68ULL;
  static const uint64_t static_value2 = 0x22d79621c90c2d42ULL;
};

template<class ContainerAllocator>
struct DataType< ::vision_msgs::system_error_<ContainerAllocator> > {
  static const char* value() 
  {
    return "vision_msgs/system_error";
  }

  static const char* value(const  ::vision_msgs::system_error_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::vision_msgs::system_error_<ContainerAllocator> > {
  static const char* value() 
  {
    return "uint64 MANIPULATION_POSE_UNREACHABLE = 64\n\
uint64 GRASP_FAILED = 128  # Grasp into the void\n\
uint64 OBJECT_NOT_FOUND = 256\n\
uint64 VISION_PRIMITIVE_FAILED = 512\n\
uint64 CONTRADICTING_TACTILE_FEEDBACK = 1024  # Collide without expecting it\n\
uint64 CONTRADICTING_VISION_RESULTS = 2048\n\
uint64 GRASP_FAILED_AND_CRASHED = 4096  # Throwing something out of the way\n\
uint64 JLO_ERROR = 8192  # Could not get position\n\
uint64 VECTOR_FIELD_CANT_REACH = 16384  # The arm got stuck along the way, did not reach the final grasping pose\n\
\n\
uint64  error_id                # One of the error constants defined above\n\
string  node_name               # The node causing this error\n\
string  error_description       # Further information about the error\n\
\n\
";
  }

  static const char* value(const  ::vision_msgs::system_error_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::vision_msgs::system_error_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.error_id);
    stream.next(m.node_name);
    stream.next(m.error_description);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct system_error_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::vision_msgs::system_error_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::vision_msgs::system_error_<ContainerAllocator> & v) 
  {
    s << indent << "error_id: ";
    Printer<uint64_t>::stream(s, indent + "  ", v.error_id);
    s << indent << "node_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.node_name);
    s << indent << "error_description: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.error_description);
  }
};


} // namespace message_operations
} // namespace ros

#endif // VISION_MSGS_MESSAGE_SYSTEM_ERROR_H

