"""autogenerated by genpy from vision_msgs/aposteriori_position.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import vision_msgs.msg

class aposteriori_position(genpy.Message):
  _md5sum = "37ac3556838265f37bdeb19748c025fb"
  _type = "vision_msgs/aposteriori_position"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#objects a posteriori position, U. Klank klank@in.tum.de
uint64 objectId                  #id of an cop object
float64 probability              #approximated a posteriori probability of the object beeing at the position
uint64 position                  #lo id of an position
cop_descriptor[] models           #list of all models assigned to the returned object
================================================================================
MSG: vision_msgs/cop_descriptor
#Descriptors of models used in cop, U. Klank klank@in.tum.de
uint64  object_id          # unique id that could be used for a query
string  sem_class          # connected semantic concept
string  type               # Class name that was used to generate the corresponding cop descriptor plugin, 
                           # example are: ShapeModel, ColorClass, DeformShapeModel
float64 quality            # the current quality assinged to this descriptor




"""
  __slots__ = ['objectId','probability','position','models']
  _slot_types = ['uint64','float64','uint64','vision_msgs/cop_descriptor[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       objectId,probability,position,models

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(aposteriori_position, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.objectId is None:
        self.objectId = 0
      if self.probability is None:
        self.probability = 0.
      if self.position is None:
        self.position = 0
      if self.models is None:
        self.models = []
    else:
      self.objectId = 0
      self.probability = 0.
      self.position = 0
      self.models = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_QdQ.pack(_x.objectId, _x.probability, _x.position))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        buff.write(_struct_Q.pack(val1.object_id))
        _x = val1.sem_class
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.quality))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.models is None:
        self.models = None
      end = 0
      _x = self
      start = end
      end += 24
      (_x.objectId, _x.probability, _x.position,) = _struct_QdQ.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = vision_msgs.msg.cop_descriptor()
        start = end
        end += 8
        (val1.object_id,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.sem_class = str[start:end].decode('utf-8')
        else:
          val1.sem_class = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 8
        (val1.quality,) = _struct_d.unpack(str[start:end])
        self.models.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_QdQ.pack(_x.objectId, _x.probability, _x.position))
      length = len(self.models)
      buff.write(_struct_I.pack(length))
      for val1 in self.models:
        buff.write(_struct_Q.pack(val1.object_id))
        _x = val1.sem_class
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_d.pack(val1.quality))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.models is None:
        self.models = None
      end = 0
      _x = self
      start = end
      end += 24
      (_x.objectId, _x.probability, _x.position,) = _struct_QdQ.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.models = []
      for i in range(0, length):
        val1 = vision_msgs.msg.cop_descriptor()
        start = end
        end += 8
        (val1.object_id,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.sem_class = str[start:end].decode('utf-8')
        else:
          val1.sem_class = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 8
        (val1.quality,) = _struct_d.unpack(str[start:end])
        self.models.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
_struct_d = struct.Struct("<d")
_struct_QdQ = struct.Struct("<QdQ")
