"""autogenerated by genpy from vision_msgs/cop_answer.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import vision_msgs.msg

class cop_answer(genpy.Message):
  _md5sum = "1f3f6145b8086e5dd7885136dd895de4"
  _type = "vision_msgs/cop_answer"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#Message that cop uses to  answer on specified topics, U. Klank klank@in.tum.de
uint64 perception_primitive         # Perception primitive that caused this answer
string error                        # eventuelly there are errors like no object found
aposteriori_position[] found_poses  # list od found pose candidate for a certain query

================================================================================
MSG: vision_msgs/aposteriori_position
#objects a posteriori position, U. Klank klank@in.tum.de
uint64 objectId                  #id of an cop object
float64 probability              #approximated a posteriori probability of the object beeing at the position
uint64 position                  #lo id of an position
cop_descriptor[] models           #list of all models assigned to the returned object
================================================================================
MSG: vision_msgs/cop_descriptor
#Descriptors of models used in cop, U. Klank klank@in.tum.de
uint64  object_id          # unique id that could be used for a query
string  sem_class          # connected semantic concept
string  type               # Class name that was used to generate the corresponding cop descriptor plugin, 
                           # example are: ShapeModel, ColorClass, DeformShapeModel
float64 quality            # the current quality assinged to this descriptor




"""
  __slots__ = ['perception_primitive','error','found_poses']
  _slot_types = ['uint64','string','vision_msgs/aposteriori_position[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       perception_primitive,error,found_poses

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(cop_answer, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.perception_primitive is None:
        self.perception_primitive = 0
      if self.error is None:
        self.error = ''
      if self.found_poses is None:
        self.found_poses = []
    else:
      self.perception_primitive = 0
      self.error = ''
      self.found_poses = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_Q.pack(self.perception_primitive))
      _x = self.error
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.found_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.found_poses:
        _x = val1
        buff.write(_struct_QdQ.pack(_x.objectId, _x.probability, _x.position))
        length = len(val1.models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.models:
          buff.write(_struct_Q.pack(val2.object_id))
          _x = val2.sem_class
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_d.pack(val2.quality))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.found_poses is None:
        self.found_poses = None
      end = 0
      start = end
      end += 8
      (self.perception_primitive,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error = str[start:end].decode('utf-8')
      else:
        self.error = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.found_poses = []
      for i in range(0, length):
        val1 = vision_msgs.msg.aposteriori_position()
        _x = val1
        start = end
        end += 24
        (_x.objectId, _x.probability, _x.position,) = _struct_QdQ.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.models = []
        for i in range(0, length):
          val2 = vision_msgs.msg.cop_descriptor()
          start = end
          end += 8
          (val2.object_id,) = _struct_Q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.sem_class = str[start:end].decode('utf-8')
          else:
            val2.sem_class = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          start = end
          end += 8
          (val2.quality,) = _struct_d.unpack(str[start:end])
          val1.models.append(val2)
        self.found_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_Q.pack(self.perception_primitive))
      _x = self.error
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.found_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.found_poses:
        _x = val1
        buff.write(_struct_QdQ.pack(_x.objectId, _x.probability, _x.position))
        length = len(val1.models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.models:
          buff.write(_struct_Q.pack(val2.object_id))
          _x = val2.sem_class
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val2.type
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_d.pack(val2.quality))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.found_poses is None:
        self.found_poses = None
      end = 0
      start = end
      end += 8
      (self.perception_primitive,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error = str[start:end].decode('utf-8')
      else:
        self.error = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.found_poses = []
      for i in range(0, length):
        val1 = vision_msgs.msg.aposteriori_position()
        _x = val1
        start = end
        end += 24
        (_x.objectId, _x.probability, _x.position,) = _struct_QdQ.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.models = []
        for i in range(0, length):
          val2 = vision_msgs.msg.cop_descriptor()
          start = end
          end += 8
          (val2.object_id,) = _struct_Q.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.sem_class = str[start:end].decode('utf-8')
          else:
            val2.sem_class = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.type = str[start:end].decode('utf-8')
          else:
            val2.type = str[start:end]
          start = end
          end += 8
          (val2.quality,) = _struct_d.unpack(str[start:end])
          val1.models.append(val2)
        self.found_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
_struct_d = struct.Struct("<d")
_struct_QdQ = struct.Struct("<QdQ")
