"""autogenerated by genpy from vision_msgs/cop_feedback.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import vision_msgs.msg

class cop_feedback(genpy.Message):
  _md5sum = "e876bab42e04aea08a659bc18c7b47cc"
  _type = "vision_msgs/cop_feedback"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#Message that cop uses to  answer on specified topics, U. Klank klank@in.tum.de
uint64         perception_primitive         # Perception primitive that caused this answer
float64        evaluation                   # A score describing the quality of the outcomes of the perception primitive
system_error[] error                        # A list of occured system failures which might be caused by the perception primitive
uint64[]       eval_whitelist               # list results which are included into the evaluation (note: default is all, not none, so an empty list means that all elements have to be evaluated, since the case that none of the results should get an evaluation does not make much sense)

================================================================================
MSG: vision_msgs/system_error
uint64 MANIPULATION_POSE_UNREACHABLE = 64
uint64 GRASP_FAILED = 128  # Grasp into the void
uint64 OBJECT_NOT_FOUND = 256
uint64 VISION_PRIMITIVE_FAILED = 512
uint64 CONTRADICTING_TACTILE_FEEDBACK = 1024  # Collide without expecting it
uint64 CONTRADICTING_VISION_RESULTS = 2048
uint64 GRASP_FAILED_AND_CRASHED = 4096  # Throwing something out of the way
uint64 JLO_ERROR = 8192  # Could not get position
uint64 VECTOR_FIELD_CANT_REACH = 16384  # The arm got stuck along the way, did not reach the final grasping pose

uint64  error_id                # One of the error constants defined above
string  node_name               # The node causing this error
string  error_description       # Further information about the error

"""
  __slots__ = ['perception_primitive','evaluation','error','eval_whitelist']
  _slot_types = ['uint64','float64','vision_msgs/system_error[]','uint64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       perception_primitive,evaluation,error,eval_whitelist

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(cop_feedback, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.perception_primitive is None:
        self.perception_primitive = 0
      if self.evaluation is None:
        self.evaluation = 0.
      if self.error is None:
        self.error = []
      if self.eval_whitelist is None:
        self.eval_whitelist = []
    else:
      self.perception_primitive = 0
      self.evaluation = 0.
      self.error = []
      self.eval_whitelist = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_Qd.pack(_x.perception_primitive, _x.evaluation))
      length = len(self.error)
      buff.write(_struct_I.pack(length))
      for val1 in self.error:
        buff.write(_struct_Q.pack(val1.error_id))
        _x = val1.node_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.error_description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.eval_whitelist)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.pack(pattern, *self.eval_whitelist))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.error is None:
        self.error = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.perception_primitive, _x.evaluation,) = _struct_Qd.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.error = []
      for i in range(0, length):
        val1 = vision_msgs.msg.system_error()
        start = end
        end += 8
        (val1.error_id,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_name = str[start:end].decode('utf-8')
        else:
          val1.node_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.error_description = str[start:end].decode('utf-8')
        else:
          val1.error_description = str[start:end]
        self.error.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.eval_whitelist = struct.unpack(pattern, str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_Qd.pack(_x.perception_primitive, _x.evaluation))
      length = len(self.error)
      buff.write(_struct_I.pack(length))
      for val1 in self.error:
        buff.write(_struct_Q.pack(val1.error_id))
        _x = val1.node_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.error_description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.eval_whitelist)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.eval_whitelist.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.error is None:
        self.error = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.perception_primitive, _x.evaluation,) = _struct_Qd.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.error = []
      for i in range(0, length):
        val1 = vision_msgs.msg.system_error()
        start = end
        end += 8
        (val1.error_id,) = _struct_Q.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.node_name = str[start:end].decode('utf-8')
        else:
          val1.node_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.error_description = str[start:end].decode('utf-8')
        else:
          val1.error_description = str[start:end]
        self.error.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.eval_whitelist = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
_struct_Qd = struct.Struct("<Qd")
