"""autogenerated by genpy from vision_msgs/system_error.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class system_error(genpy.Message):
  _md5sum = "a26e239d3a42fd6822d79621c90c2d42"
  _type = "vision_msgs/system_error"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint64 MANIPULATION_POSE_UNREACHABLE = 64
uint64 GRASP_FAILED = 128  # Grasp into the void
uint64 OBJECT_NOT_FOUND = 256
uint64 VISION_PRIMITIVE_FAILED = 512
uint64 CONTRADICTING_TACTILE_FEEDBACK = 1024  # Collide without expecting it
uint64 CONTRADICTING_VISION_RESULTS = 2048
uint64 GRASP_FAILED_AND_CRASHED = 4096  # Throwing something out of the way
uint64 JLO_ERROR = 8192  # Could not get position
uint64 VECTOR_FIELD_CANT_REACH = 16384  # The arm got stuck along the way, did not reach the final grasping pose

uint64  error_id                # One of the error constants defined above
string  node_name               # The node causing this error
string  error_description       # Further information about the error

"""
  # Pseudo-constants
  MANIPULATION_POSE_UNREACHABLE = 64
  GRASP_FAILED = 128
  OBJECT_NOT_FOUND = 256
  VISION_PRIMITIVE_FAILED = 512
  CONTRADICTING_TACTILE_FEEDBACK = 1024
  CONTRADICTING_VISION_RESULTS = 2048
  GRASP_FAILED_AND_CRASHED = 4096
  JLO_ERROR = 8192
  VECTOR_FIELD_CANT_REACH = 16384

  __slots__ = ['error_id','node_name','error_description']
  _slot_types = ['uint64','string','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       error_id,node_name,error_description

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(system_error, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.error_id is None:
        self.error_id = 0
      if self.node_name is None:
        self.node_name = ''
      if self.error_description is None:
        self.error_description = ''
    else:
      self.error_id = 0
      self.node_name = ''
      self.error_description = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_Q.pack(self.error_id))
      _x = self.node_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.error_description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 8
      (self.error_id,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node_name = str[start:end].decode('utf-8')
      else:
        self.node_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error_description = str[start:end].decode('utf-8')
      else:
        self.error_description = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_Q.pack(self.error_id))
      _x = self.node_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.error_description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 8
      (self.error_id,) = _struct_Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.node_name = str[start:end].decode('utf-8')
      else:
        self.node_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.error_description = str[start:end].decode('utf-8')
      else:
        self.error_description = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
