"""autogenerated by genpy from vision_srvs/cop_callRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import vision_msgs.msg

class cop_callRequest(genpy.Message):
  _md5sum = "8159879f6a0c16d501638a9c44ad2860"
  _type = "vision_srvs/cop_callRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

uint64 LOCATE = 0
uint64 TRACK  = 16
uint64 REFINE  = 256
uint64 STOPTRACK = 2048
uint64 STARTATTENT = 4096
uint64 STOPATTENT = 8192
uint64 LOOKUP = 25600
uint64 LOOKUPALL = 25601

string outputtopic
string[] object_classes
uint64[] object_ids
uint64 action_type
uint64 number_of_objects
vision_msgs/apriori_position[] list_of_poses

================================================================================
MSG: vision_msgs/apriori_position
#Tuple for cop call
float64 probability # apriori probability of the position
uint64 positionId  # lo id of an position

"""
  # Pseudo-constants
  LOCATE = 0
  TRACK = 16
  REFINE = 256
  STOPTRACK = 2048
  STARTATTENT = 4096
  STOPATTENT = 8192
  LOOKUP = 25600
  LOOKUPALL = 25601

  __slots__ = ['outputtopic','object_classes','object_ids','action_type','number_of_objects','list_of_poses']
  _slot_types = ['string','string[]','uint64[]','uint64','uint64','vision_msgs/apriori_position[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       outputtopic,object_classes,object_ids,action_type,number_of_objects,list_of_poses

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(cop_callRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.outputtopic is None:
        self.outputtopic = ''
      if self.object_classes is None:
        self.object_classes = []
      if self.object_ids is None:
        self.object_ids = []
      if self.action_type is None:
        self.action_type = 0
      if self.number_of_objects is None:
        self.number_of_objects = 0
      if self.list_of_poses is None:
        self.list_of_poses = []
    else:
      self.outputtopic = ''
      self.object_classes = []
      self.object_ids = []
      self.action_type = 0
      self.number_of_objects = 0
      self.list_of_poses = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.outputtopic
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object_classes)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_classes:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.object_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.pack(pattern, *self.object_ids))
      _x = self
      buff.write(_struct_2Q.pack(_x.action_type, _x.number_of_objects))
      length = len(self.list_of_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.list_of_poses:
        _x = val1
        buff.write(_struct_dQ.pack(_x.probability, _x.positionId))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.list_of_poses is None:
        self.list_of_poses = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.outputtopic = str[start:end].decode('utf-8')
      else:
        self.outputtopic = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_classes = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.object_classes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.object_ids = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 16
      (_x.action_type, _x.number_of_objects,) = _struct_2Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.list_of_poses = []
      for i in range(0, length):
        val1 = vision_msgs.msg.apriori_position()
        _x = val1
        start = end
        end += 16
        (_x.probability, _x.positionId,) = _struct_dQ.unpack(str[start:end])
        self.list_of_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.outputtopic
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.object_classes)
      buff.write(_struct_I.pack(length))
      for val1 in self.object_classes:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.object_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.object_ids.tostring())
      _x = self
      buff.write(_struct_2Q.pack(_x.action_type, _x.number_of_objects))
      length = len(self.list_of_poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.list_of_poses:
        _x = val1
        buff.write(_struct_dQ.pack(_x.probability, _x.positionId))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.list_of_poses is None:
        self.list_of_poses = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.outputtopic = str[start:end].decode('utf-8')
      else:
        self.outputtopic = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.object_classes = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.object_classes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.object_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 16
      (_x.action_type, _x.number_of_objects,) = _struct_2Q.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.list_of_poses = []
      for i in range(0, length):
        val1 = vision_msgs.msg.apriori_position()
        _x = val1
        start = end
        end += 16
        (_x.probability, _x.positionId,) = _struct_dQ.unpack(str[start:end])
        self.list_of_poses.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2Q = struct.Struct("<2Q")
_struct_dQ = struct.Struct("<dQ")
"""autogenerated by genpy from vision_srvs/cop_callResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class cop_callResponse(genpy.Message):
  _md5sum = "44338ff3890880904a6cc02046a2df09"
  _type = "vision_srvs/cop_callResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint64 perception_primitive

"""
  __slots__ = ['perception_primitive']
  _slot_types = ['uint64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       perception_primitive

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(cop_callResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.perception_primitive is None:
        self.perception_primitive = 0
    else:
      self.perception_primitive = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_Q.pack(self.perception_primitive))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 8
      (self.perception_primitive,) = _struct_Q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_Q.pack(self.perception_primitive))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 8
      (self.perception_primitive,) = _struct_Q.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_Q = struct.Struct("<Q")
class cop_call(object):
  _type          = 'vision_srvs/cop_call'
  _md5sum = 'df853a883b53431ef52c184e4ff2b0b3'
  _request_class  = cop_callRequest
  _response_class = cop_callResponse
